<?php
namespace api_pay;
class pay_yandexmoney {

    public function Get_Balance(&$ps)
    {
        $ret = FALSE;
        if(empty($ps['ApiToken']))
            return $ret;
        $balance_info = self::sendRequest(
                '/api/account-info',
                array(),
                $ps['ApiToken']
            );
        $yaisAuth = !empty($balance_info->balance) ? TRUE : FALSE;
        if($yaisAuth)
            $ret = $balance_info->balance;
        return $ret;
    }
    public function SendTo(&$p,&$ps)
    {
        $ret = array('ok' => FALSE,'err' => 'Повторите попытку позже');
        if(empty($ps['ApiToken'])){
            $ret['err'] = "Не получен токен. Получите токен в настройках ПС";
            return $ret;
        }
        if((int)$ps['PerOut'] !== 0)
            $p['Amount'] = $p['Amount'] + $p['Amount']*($ps['PerOut']/100);
        $yareq = self::sendRequest(
            '/api/request-payment',
            array(
                'client_id'=>$ps['ApiId'],
                'pattern_id'=>'p2p',
                'to'=>trim($p['Number']),
                'amount_due'=>$p['Amount'],
                'message'=>$GLOBALS['setting']['main']['short_org'] . ' - Заявка на вывод средств №'.$p['Id'],
                'comment'=>$GLOBALS['setting']['main']['short_org'] . ' - Заявка на вывод средств №'.$p['Id'],
                'test_payment' => 'false',
            ),
            $ps['ApiToken']
        );
        if($yareq->status == 'success'){
            $yareq2 = self::sendRequest(
            '/api/process-payment',
                array(
                    'request_id'=>$yareq->request_id,
                ),
                $ps['ApiToken']
            );
            if($yareq2->status == 'success'){
                $ret['ok'] = TRUE;
            }
            else
                $dat['feed'] = '<div class="alert alert-danger"><strong>Произошла ошибка!</strong> '.$yareq2->error.'</div>';
        }
        else
            $dat['feed'] = '<div class="alert alert-danger"><strong>Произошла ошибка!</strong> '.$yareq->error.'</div>';
        return $ret;
    }
    public function __construct()
    {}
    public static function sendRequest($url, $options=array(), $access_token=NULL,$cont = FALSE) {

        if(strpos($url, "https") === false) {
            $full_url= "https://money.yandex.ru" . $url;
        }
        else {
            $full_url = $url;
        }
        $curl = curl_init($full_url);
        if($access_token !== NULL) {
            curl_setopt($curl, CURLOPT_HTTPHEADER, array(
                "Authorization: Bearer " . $access_token
            ));
        }
        curl_setopt ($curl, CURLOPT_USERAGENT, 'Yandex.Money.SDK/PHP');
        curl_setopt ($curl, CURLOPT_POST, 1);
        $query = http_build_query($options);
        curl_setopt ($curl, CURLOPT_POSTFIELDS, $query);
        curl_setopt ($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_HEADER, 0);
        //curl_setopt($curl, CURLOPT_VERBOSE, 1);
        curl_setopt ($curl, CURLOPT_SSL_VERIFYPEER, true);
        curl_setopt ($curl, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt ($curl, CURLOPT_SSL_VERIFYHOST, 2);
        $body = curl_exec ($curl);
        //var_dump($body);die();
        $result = new \StdClass();
        $result->status_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $result->body = $body;
        curl_close ($curl);
        return $cont ? $result : self::processResult($result);
    }

    protected static function processResult($result) {
        switch ($result->status_code) {
            case 400:
                throw new Exceptions\FormatError;
                break;
            case 401:
                throw new Exceptions\TokenError;
                break;
            case 403:
                throw new Exceptions\ScopeError;
                break;
            default:
                if($result->status_code >= 500) {
                    throw new Exceptions\ServerError($result->status_code);
                }
                else {
                    return json_decode($result->body);
                }
        }
    }
}

class APIException extends \Exception {

}
class FormatError extends APIException {
    public function __construct() {
        parent::__construct(
            "Request is missformated", 400
        );
    }
}

class ScopeError extends APIException {
    public function __construct() {
        parent::__construct(
            "Scope error. Obtain new access_token from user"
            . "with extended scope", 403
        );
    }
}

class TokenError extends APIException {
    public function __construct() {
        parent::__construct("Token is expired or incorrect", 401);
    }
}

class ServerError extends APIException {
    public function __construct($status_code) {
        parent::__construct("Server error", $status_code);
    }
}
