<?php
namespace models;
if ( ! defined('F')) exit('Нет доступа!');
class Base_model
{
	function __construct(){}
	protected function con(){
		$conf = array();
        if (($h = @fopen(F."/config/db.conf", "r"))) {
            while (($c = fgets($h, 4096)) !== false) {
                $c = explode(':',$c);
                if(!empty($c[0]) && !empty($c[1])){
                   $conf[trim($c[0])] = trim($c[1]);
                }
            }
            fclose($h);
        }
        if(!isset($conf['host'],$conf['login'],$conf['pass'],$conf['db'])){
            include F.'views/errors/error_bd.php';
            die();
        }
		$conn = new \mysqli($conf['host'], $conf['login'], $conf['pass'], $conf['db']);
		unset($conf);
	    if (empty($conn) || $conn->connect_error) {
            include F.'views/errors/error_bd.php';
            die();
        }
	    $conn->set_charset("utf8");
		return $conn;
	}
	protected function b_insert($table,$data,$ch = TRUE){
		$conn = $this->con();
        $k = array();
        $v = array();
        foreach ($data as $key => $val) {
        	$t = gettype($val);
        	if($t != "boolean" && $t != "integer" && $t != "double")
        		$val = "'".$conn->real_escape_string($val)."'";
            elseif ($t == "double") 
                $val = str_replace(',', '.', $val);
            array_push($k, '`'.$conn->real_escape_string(trim($key)).'`');
            array_push($v, $val);
        }
        $sql = 'INSERT INTO `'.$conn->real_escape_string(trim($table)).'` ('.implode(',', $k).') VALUES ('.implode(',', $v).')';
        $ret = 0;
        //echo $sql.'<br/>';
        //die($sql);
		if($conn->query($sql))
			$ret = !$conn->insert_id ? TRUE : $conn->insert_id;
		$conn->close();
		return $ret;
	}
	protected function b_update($table,$data,$id,$ch = TRUE){
		$conn = $this->con();
		$k = array();
        foreach ($data as $key => $val) {
            $t = gettype($val);
            if($t != "boolean" && $t != "integer" && $t != "double")
            	$val = "'".$conn->real_escape_string($val)."'";
            elseif ($t == "double") 
                $val = str_replace(',', '.', $val);
            $key = $conn->real_escape_string($key);
            array_push($k, "`{$key}` = {$val}");
        }
        $w = '';
        if(is_array($id)){
            $t_ar = array();
            foreach ($id as $key => $val) {
                $t = gettype($val);
                if($t != "boolean" && $t != "integer" && $t != "double")
                    $val = "'".$conn->real_escape_string($val)."'";
                elseif ($t == "double") 
                    $val = str_replace(',', '.', $val);
                $key = $conn->real_escape_string($key);
                array_push($t_ar, "`{$key}` = {$val}");
            }
            if(empty($t_ar))
                return FALSE;
            $w = implode(' AND ', $t_ar);
        }
        else
            $w = '`Id` = '.(int)$id;
	    $sql = 'UPDATE `'.$conn->real_escape_string(trim($table)).'` SET '.implode(',', $k).' WHERE '.$w;
        //die($sql);
        //echo $sql;
	    $ret = $conn->query($sql);
        //$ret = $conn->affected_rows;
		$conn->close();
		return ($ret > 0) ? TRUE : FALSE;
	}    
    public function b_chek($table, $key, $val)
    {
        $conn = $this->con();
        $ret = FALSE;
        $t = gettype($val);
        if($t != "boolean" && $t != "integer" && $t = "double")
            $val = "'".$conn->real_escape_string($val)."'";
        elseif ($t == "double")
            $val = str_replace(',', '.', $val);
        $key = $conn->real_escape_string($key);            
        $query = $conn->query("SELECT * FROM ".$conn->real_escape_string(trim($table))." WHERE `{$key}` = {$val} LIMIT 1");
        if (!empty($query) && $query->num_rows > 0){
            $ret = TRUE;
            $query->close();
        }
        $conn->close();
        return $ret;
    }
    public function b_chekArr($tb, $arr, $sep = "AND")
{
    $tmp = [];
    foreach ($arr as $key => $val) {
        // 🔧 Fixed comparison operator from '==' to '='
        $tmp[] = "$key = '$val'";
    }
    
    $sql = "SELECT * FROM $tb WHERE " . implode(" $sep ", $tmp);
    $query = $this->con()->query($sql);
    
    if ($query && $query->num_rows > 0) {
        return $query->fetch_assoc();
    }
    
    return false;
}

    public  function Insert_admin_error_log(){
        $data = array('Date' => time(), 'Ip' => sprintf('%u', ip2long(getIP())));
        $this->b_insert('admin_login_log',$data,0);
    }
    public  function chek_admin_error_log($time = 4)
    {
        $conn = $this->con();
        $ret = 0;
        $time = time() - $time*60*60;
        $ip = getIP();
        $query2 = $conn->query("SELECT COUNT(*) FROM `admin_login_log` WHERE `Ip` = INET_ATON('{$ip}') AND `Date` > {$time} LIMIT 100");
        if(!empty($query2)){
            $ret = (int)$query2->fetch_array()[0];
            $query2->close();
        }
        $conn->close();
        return $ret;
    }
}
