<?php 
namespace controls\task {
    // Ensure direct access to the file is prevented
    defined('F') OR exit('No direct access!');
    // Include the Pages_model for handling page-related data
    require_once(F."models/pages/Pages_model.php");

    /**
     * Main function to handle task display and management.
     * It processes various POST requests for task operations (add, edit, delete, balance change, etc.)
     * and prepares data for displaying task lists or individual task details.
     */
    function r()
    {
        // If 'stat' GET parameter is present, call get_stat function
        if(!empty($_GET['stat']))
            return get_stat((int)$_GET['stat']);

        // Declare global variables for user and application settings
        global $URLparam,$user_logined, $user_login, $user_m, $setting;
        // Include the Task_model for handling task-specific data
        require_once(F."/moduls/task/models/Task_model.php");
        // Create a new instance of the Task_model
        $r_m = new \models\moduls\Task_model;
        // Define module path
        $F = F.'moduls/task';
        // Initialize data array
        $dat = array();     
        $mod = 'rtask';
        // Define the view path for task rendering
        $view = '/moduls/task/views/r';
        $data = array();
        // Check if it's an AJAX request
        $aj = !empty($_POST['aj']) ? TRUE : FALSE;
        // Get any redirect messages
        $dat['feed'] = form_redirect();

        /********************************************/
        // Get article information related to tasks from the Pages_model
        $art_m = new \models\pages\Pages_model;
        $art = $art_m->GetById('rtask',TRUE);
        // Set default article data if not found
        if(empty($art))
            $art = array('Title'=>'Tasks','Body'=>'','MetaKey'=>'','MetaDesc'=>'Tasks');
        /********************************************/
        // Get task categories
        $dat['Cats'] = $r_m->GetsCat();
        $dat['r_m'] = &$r_m;

        // If user is logged in, process task management
        if($user_logined){
            // Check for user block status and message
            $t = $r_m->ChBlokComm();
            if(!empty($t)){
                $dat['ChBlok'] = $t['Blok'];
                $dat['ChBlokComm'] = $t['Comm'];
            }
            else
                $dat['ChBlok'] = FALSE;
            unset($t);

            // If user is not blocked, proceed with task operations
            if(!$dat['ChBlok']){
                /***********************up_ins***************************/
                // Handle 'show_item' request to display task details
                if(isset($_POST['show_item'])){
                    $ar = array();
                    $ar['add'] = TRUE;
                    $ar['r_m'] = &$r_m;
                    $ar['Cats'] = &$dat['Cats'];
                    if(!empty($_POST['show_item'])){
                        $t = $r_m->GetByID($_POST['show_item']);
                        if(!empty($t) && $t['UserId'] == $user_login->data['Id']){
                            $t['Reg'] = $r_m->GetReg($t['Id']);
                            $ar['add'] = FALSE;
                            $ar = array_merge($ar,$t);
                        }
                    }
                    // Display the task item view and exit
                    \view\content_show('/moduls/task/views/r_item', $ar);
                    die();
                }
                // Handle 'prv_show' request to display task reports
                elseif(isset($_POST['prv_show'])){
                    $t = $r_m->GetByID_s($_POST['prv_show'],$user_login->data['Id']);
                    if(!empty($t)){
                        $ot = $r_m->GetsU(array('TaskId' => $t['Id'], 'Status' => 2));
                        // Display the task item report view and exit
                        \view\content_show('/moduls/task/views/r_item_ot', array('ot' => $ot->data, 'Id' => $t['Id'], 'r_m' => &$r_m));
                        die();
                    }
                }
                // Handle task activation/deactivation ('Active_up', 'ItemId')
                elseif(isset($_POST['Active_up'],$_POST['ItemId'])){
                    if($r_m->Update(array('Id'=>$_POST['ItemId'],'Active'=>$_POST['Active_up'])))
                        $dat['feed'] = form_redirect_send('<div class="alert alert-success">Data successfully updated!</div>');
                    else
                        $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                }
                // Handle approval of task report ('otchetok')
                elseif(isset($_POST['otchetok'])){
                    $it = $r_m->GetByIDU_r($_POST['otchetok']);
                    if(!empty($it) && $it['TaskUserId'] == $user_login->data['Id'] && $it['Status'] < 4){
                        if($r_m->UpdateU(array('Id' => $it['Id'],'Status' => 4,'OkDate'=>time()),TRUE)){
                            $user_m->MoneyPlus($it['UserId'],$it['Amount'],13); // Add money to user
                            $dat['feed'] = form_redirect_send('<div class="alert alert-success"><strong>Report approved!</strong> Task completed.</div>');
                            $im = $this->GetImg($it['Id']);
                            if(!empty($im))
                                unlink(F.$im); // Delete associated image file
                        }
                        else
                            $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                    }
                    else
                        $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                }
                // Handle sending task for revision ('otcheterr', 'Dorabotka')
                elseif(isset($_POST['otcheterr'],$_POST['Dorabotka'])){
                    $it = $r_m->GetByIDU_r($_POST['otcheterr']);
                    if(!empty($it) && $it['TaskUserId'] == $user_login->data['Id'] && $it['Status'] < 4){
                        if($r_m->UpdateU(array(
                                'Id' => $it['Id'],
                                'Status' => 3, // Set status to "needs revision"
                                'Dorabotka' => $_POST['Dorabotka'], // Store revision message
                                'Otchet' => '', // Clear previous report
                                'EndDate' => time()+(60*60*24), // Extend end date by 24 hours for revision
                                'OkDate'=>time()+(60*60*24),
                            ),TRUE)){
                            $dat['feed'] = form_redirect_send('<div class="alert alert-success"><strong>Task sent for revision!</strong></div>');
                        }
                        else
                            $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                    }
                    else
                        $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                }
                // Handle blocking a user for a task ('blok', 'Comment')
                elseif(isset($_POST['blok'])){
                    if(empty($_POST['Comment'])){
                        $dat['feed'] = form_redirect_send('<div class="alert alert-danger"><strong>Error!</strong> Reason for blocking not specified.</div>');
                    }
                    else{
                        $it = $r_m->GetByIDU_r($_POST['blok']);
                        if(!empty($it) && $it['TaskUserId'] == $user_login->data['Id'] && $it['Status'] < 4){
                            if($r_m->UpdateU(array(
                                    'Id' => $it['Id'],
                                    'Status' => 7, // Set status to "blocked by advertiser"
                                    'BlokMess' => $_POST['Comment'], // Store blocking message
                                    'OkDate'=>time(),
                                ),TRUE)){
                                $r_m->Update(array('Id' => $it['TaskId'], 'Balans' => $it['TaskBalans'] + $it['AmountPer'])); // Refund task balance
                                $dat['feed'] = form_redirect_send('<div class="alert alert-success"><strong>User blocked!</strong> Task completed.</div>');
                                $im = $this->GetImg($it['Id']);
                                if(!empty($im))
                                    unlink(F.$im); // Delete associated image file
                            }
                            else
                                $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                        }
                        else
                            $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                    }
                }
                // Handle task promotion ('task_up')
                elseif(isset($_POST['task_up'])){
                    if($user_login->data['MoneyR'] < $r_m->set['price_up'])
                        $dat['feed'] = form_redirect_send('<div class="alert alert-danger"><strong>An error occurred!</strong> You do not have enough funds in your advertising account.</div>');
                    elseif($user_m->MoneyMinus($user_login->data['Id'],$r_m->set['price_up'],12,$user_login)){
                        if($r_m->Update(array('Id'=>$_POST['task_up'],'Sort'=>time()))) // Update sort order to bring task to top
                            $dat['feed'] = form_redirect_send('<p class="alert alert-success">Task promoted!</p>');
                        else
                            $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                    }
                    else
                        $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                }
                // Handle task update ('Update')
                elseif(isset($_POST['Update'])){
                    $ar = $_POST;
                    $ar['Id'] = $_POST['Update'];
                    $ar['Refer'] = (!empty($_POST['Refer'])) ? 1 : 0;
                    $ar['Active'] = empty($ar['Active']) ? 0 : 1;
                    $ar['reg'] = array();
                    // Handle moderation status
                    if($ar['Approved'] < 0 || $r_m->set['moderat'])
                        $ar['Approved'] = 0; // Set to pending approval if moderation is enabled
                    else
                        unset($ar['Approved']); // Remove if moderation is disabled
                    // Process regional restrictions
                    if(isset($ar['reg_country']) && is_array($ar['reg_country'])){
                        foreach ($ar['reg_country'] as $k => $val) {
                            $t = array();
                            $t['Country'] = $val;
                            if(isset($ar['reg_obl'][$k]))
                                $t['Obl'] = $ar['reg_obl'][$k];
                            array_push($ar['reg'], $t);
                            unset($t);
                        }
                    }
                    if($r_m->Update($ar)){
                        $dat['feed'] = form_redirect_send('<div class="alert alert-success">Data successfully updated!</div>');
                    }
                    else
                        $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                }
                // Handle new task insertion ('Insert')
                elseif(isset($_POST['Insert'])){
                    $ar = $_POST;
                    $ar['UserId'] = $user_login->data['Id'];
                    $ar['reg'] = array();
                    $ar['Refer'] = (!empty($_POST['Refer'])) ? 1 : 0;
                    $ar['Approved'] = ($r_m->set['moderat']) ? 0 : 1; // Set approval status based on moderation setting
                    $ar['Active'] = empty($ar['Active']) ? 0 : 1;
                    // Process regional restrictions
                    if(isset($ar['reg_country']) && is_array($ar['reg_country'])){
                        foreach ($ar['reg_country'] as $k => $val) {
                            $t = array();
                            $t['Country'] = $val;
                            if(isset($ar['reg_obl'][$k]))
                                $t['Obl'] = $ar['reg_obl'][$k];
                            array_push($ar['reg'], $t);
                            unset($t);
                        }
                    }
                    if(($ins_id = $r_m->Insert($ar))){
                        $dat['feed'] = form_redirect_send('<div class="alert alert-success">Task added!</div>');
                    }
                    else
                        $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                }
                // Handle task deletion ('DeletItem')
                elseif(isset($_POST['DeletItem'])){
                    $t = $r_m->GetByID_s($_POST['DeletItem'],$user_login->data['Id']);
                    if(!empty($t)){
                        $t_sum = $t['Balans'];
                        if($r_m->Delete($_POST['DeletItem'])){
                            if($t_sum > 0)
                                $user_m->MoneyPlus($user_login->data['Id'],$t_sum,12,$user_login); // Refund task balance to user
                            $dat['feed'] = form_redirect_send('<div class="alert alert-success">Data successfully updated!</div>');
                        }
                        else
                            $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, please check the entered data and try again!</div>');
                    }
                    else
                        $dat['feed'] = form_redirect_send('<div class="alert alert-danger">An error occurred, task not found!</div>');
                    unset($t);
                }
                // Handle task balance changes ('balans_change', 'Balans')
                elseif(isset($_POST['balans_change'],$_POST['Balans'])){
                    $t = $r_m->GetByID($_POST['balans_change']);
                    if(empty($t) || $t['UserId'] != $user_login->data['Id']){
                        unset($t);
                        $dat['feed'] = form_redirect_send('<div class="alert alert-danger"><strong>An error occurred!</strong> Check the data and try again.</div>');
                    }
                    else{
                        $sum = mav_float($_POST['Balans'],2); // Sanitize balance input
                        if($t['Balans'] > $sum){ // If balance is decreased, refund the difference
                            $sum_ret = $t['Balans'] - $sum;
                            if($r_m->Update(array('Id' => $_POST['balans_change'], 'Balans' => $sum))){
                                if($user_m->MoneyPlus($user_login->data['Id'],$sum_ret,12,$user_login))
                                    $dat['feed'] = form_redirect_send('<p class="alert alert-success">Balance successfully updated!</p>');
                                else
                                    $dat['feed'] = form_redirect_send('<div class="alert alert-danger"><strong>An error occurred!</strong> Please contact site administration.</div>'); 
                                $user_login = $user_m->get(); // Refresh user login data
                            }
                            else
                                $dat['feed'] = form_redirect_send('<div class="alert alert-danger"><strong>An error occurred!</strong> Check the data and try again.</div>'); 
                        }
                        elseif($t['Balans'] < $sum){ // If balance is increased, deduct from user's ad account
                            $sum_ret = $sum - $t['Balans'];
                            if($sum_ret > $user_login->data['MoneyR'])
                                $dat['feed'] = form_redirect_send('<div class="alert alert-danger"><strong>An error occurred!</strong> You do not have enough funds in your advertising account.</div>');
                            else{
                                if($user_m->MoneyMinus($user_login->data['Id'],$sum_ret,12,$user_login)){
                                    $r_m->Update(array('Id' => $_POST['balans_change'], 'Balans' => $sum));
                                    $dat['feed'] = form_redirect_send('<p class="alert alert-success">Balance successfully updated!</p>');
                                    $user_login = $user_m->get(); // Refresh user login data
                                }
                                else
                                    $dat['feed'] = form_redirect_send('<div class="alert alert-danger"><strong>An error occurred!</strong> Check the data and try again.</div>');
                            } 
                        }
                        else
                            $dat['feed'] = form_redirect_send('<div class="alert alert-danger"><strong>An error occurred!</strong> Check the data and try again.<strong>An error occurred!</strong> Check the data and try again.</div>');
                    }            
                }
                /**************Selection Filter****************/
                $url_build = array();
                $filtr = array('UserId' => $user_login->data['Id'],'r' => 1); // Filter by logged-in user and 'r' (likely "ready" or "active")
                /**************Pagination***********************/
                $pagevis = 30; // Items per page
                $startpag = 1; // Current page number
                if(isset($_POST['startpag']))
                    $startpag = (int)$_POST['startpag'];
                elseif(isset($_GET['startpag']) && empty($_POST['aj'])) 
                    $startpag = (int)$_GET['startpag'];
                if(!$startpag)
                    $startpag = 1;
                elseif($startpag > 1)
                    $url_build['startpag'] = $startpag;
                $dat['startpag'] = $startpag;
                $startpag = ($startpag-1)*$pagevis; // Calculate offset for database query

                /**************Sorting**********************/
                $dat['sort'] = ''; // Sort order
                if(isset($_POST['sort']))
                    $dat['sort'] = $_POST['sort'];
                elseif (isset($_GET['sort']) && empty($_POST['aj'])) 
                    $dat['sort'] = $_GET['sort'];
                if(!empty($dat['sort']))
                    $url_build['sort'] = $dat['sort'];     

                /**********************************/
                // Get tasks based on filter, pagination, and sort
                $dat['items'] = $r_m->Gets($filtr,$startpag, $pagevis, $dat['sort']);
                $dat['r_ot'] = array();
                // Separate tasks with 'st2' status (likely "pending review")
                if(!empty($dat['items']) && !empty($dat['items']->data)){            
                    foreach ($dat['items']->data as $val)    
                    {
                        if($val['st2'] > 0)
                            array_push($dat['r_ot'], $val);
                    }
                }
                // Generate pagination links
                $dat['pager'] = ($dat['items']->count > $pagevis) ? \view\getpager($startpag,$pagevis,$dat['items']->count, '', 'pager') : '';
                // Build the base URL for pagination
                $dat['url_build'] = empty($url_build) ? URLpage : URLpage.'?'.urldecode(http_build_query($url_build));
                $dat['filtr'] = $filtr;
                unset($filtr,$url_build,$startpag);
                $dat['aj'] = $aj;
                /**************************************************/
            }
        }
        /*****************Breadcrumbs***************/        
        $tbred = '';
        $data['breadcrumbs'] = '<li><a href="/" title="Home">Home</a></li> ';
        // Build breadcrumbs dynamically based on parent articles
        if(!empty($art['ParentArt'])){
            $tek = $art['ParentArt'];
            while(1){
                $tbred .= '<li><a href="'.$tek['Url'].'" title="'.$tek['Title'].'">'.$tek['Title'].'</a></li> ' . $tbred;
                if(empty($tek['ParentArt']))
                    break;
                $tek = $tek['ParentArt'];
            }
        }
        $data['breadcrumbs'] .= $tbred."<li>{$art['Title']}</li>";
        /************************************************/
        // Set page title and body content
        $dat['Title'] = $art['Title'];
        $dat['Body'] = $art['Body'];
        // If it's an AJAX request, display content and exit
        if(!empty($aj)){
            \view\content_show($view, $dat);
            die();
        }
        // Render the main content
        $data['content'] = \view\content_show($view, $dat, TRUE);
        // Set meta titles, descriptions, and keywords
        $data['Title'] = !empty($art['MetaTitle']) ? $art['MetaTitle'] : $art['Title'];
        $data['Desc'] = $art['MetaDesc'];
        $data['Key'] = $art['MetaKey'];
        /*$data['og_type'] = 'article';
        $data['og_image'] = "";*/
        return $data;
    }

    /**
     * Function to get and display task statistics.
     * @param int $id The ID of the task for which to display statistics.
     */
    function get_stat($id){
        // Declare global variables for user and application settings
        global $URLparam,$user_logined, $user_login, $user_m, $setting;
        // Include the Task_model for handling task-specific data
        require_once(F."/moduls/task/models/Task_model.php");
        // Create a new instance of the Task_model
        $r_m = new \models\moduls\Task_model;
        // Define module path
        $F = F.'moduls/task';
        // Initialize data array
        $dat = array();     
        $mod = 'rtask';
        // Define the view path for task statistics rendering
        $view = '/moduls/task/views/r_stat';
        $data = array();
        // Check if it's an AJAX request
        $aj = !empty($_POST['aj']) ? TRUE : FALSE;
        // Get any redirect messages
        $dat['feed'] = form_redirect();

        /********************************************/
        // Set article information for task statistics
        $art = array('Title'=>'Task Execution Statistics №'.$id,'Body'=>'','MetaKey'=>'','MetaDesc'=>'Task Execution Statistics №'.$id);
        /********************************************/
        // Get task categories
        $dat['Cats'] = $r_m->GetsCat();
        // If user is logged in, process task statistics
        if($user_logined){
            // Check for user block status and message
            $t = $r_m->ChBlokComm();
            if(!empty($t)){
                $dat['ChBlok'] = $t['Blok'];
                $dat['ChBlokComm'] = $t['Comm'];
            }
            else
                $dat['ChBlok'] = FALSE;

            // If user is not blocked, proceed with statistics retrieval
            if(!$dat['ChBlok']){
                // Get task details by ID and user ID
                $t = $r_m->GetByID_s($id,$user_login->data['Id']);
                // If task not found or doesn't belong to the user, trigger a 404 error
                if(empty($t))
                    e404();
                $dat['TaskTitle'] = $t['Title'];
                unset($t);

                /**************Selection Filter****************/
                $url_build = array();
                $filtr = array('TaskId' => $id); // Filter statistics by specific TaskId
                /**************Pagination***********************/
                $pagevis = 30; // Items per page
                $startpag = 1; // Current page number
                if(isset($_POST['startpag']))
                    $startpag = (int)$_POST['startpag'];
                elseif(isset($_GET['startpag']) && empty($_POST['aj'])) 
                    $startpag = (int)$_GET['startpag'];
                if(!$startpag)
                    $startpag = 1;
                elseif($startpag > 1)
                    $url_build['startpag'] = $startpag;
                $dat['startpag'] = $startpag;
                $startpag = ($startpag-1)*$pagevis; // Calculate offset for database query

                /**************Sorting**********************/
                $dat['sort'] = ''; // Sort order
                if(isset($_POST['sort']))
                    $dat['sort'] = $_POST['sort'];
                elseif (isset($_GET['sort']) && empty($_POST['aj'])) 
                    $dat['sort'] = $_GET['sort'];
                if(!empty($dat['sort']))
                    $url_build['sort'] = $dat['sort'];     

                /**********************************/
                // Get task execution records (user submissions) for the specific task
                $dat['items'] = $r_m->GetsU($filtr,$startpag, $pagevis, $dat['sort']);           
                // Generate pagination links
                $dat['pager'] = ($dat['items']->count > $pagevis) ? \view\getpager($startpag,$pagevis,$dat['items']->count, '', 'pager') : '';
                // Build the base URL for pagination
                $dat['url_build'] = empty($url_build) ? URLpage : URLpage.'?'.urldecode(http_build_query($url_build));
                $dat['filtr'] = $filtr;
                unset($filtr,$url_build,$startpag);
                $dat['aj'] = $aj;
                $dat['r_m'] = &$r_m; // Pass model reference to the view
                /**************************************************/
            }
        }
        /*****************Breadcrumbs***************/        
        $tbred = '';
        $data['breadcrumbs'] = '<li><a href="/" title="Home">Home</a></li> ';
        // Build breadcrumbs dynamically based on parent articles (though likely not applicable for stats page in the same way)
        if(!empty($art['ParentArt'])){
            $tek = $art['ParentArt'];
            while(1){
                $tbred .= '<li><a href="'.$tek['Url'].'" title="'.$tek['Title'].'">'.$tek['Title'].'</a></li> ' . $tbred;
                if(empty($tek['ParentArt']))
                    break;
                $tek = $tek['ParentArt'];
            }
        }
        $data['breadcrumbs'] .= $tbred."<li>{$art['Title']}</li>";
        /************************************************/
        // Set page title and body content
        $dat['Title'] = $art['Title'];
        $dat['Body'] = $art['Body'];
        // If it's an AJAX request, display content and exit
        if(!empty($aj)){
            \view\content_show($view, $dat);
            die();
        }
        // Render the main content
        $data['content'] = \view\content_show($view, $dat, TRUE);
        // Set meta titles, descriptions, and keywords
        $data['Title'] = !empty($art['MetaTitle']) ? $art['MetaTitle'] : $art['Title'];
        $data['Desc'] = $art['MetaDesc'];
        $data['Key'] = $art['MetaKey'];
        /*$data['og_type'] = 'article';
        $data['og_image'] = "";*/
        return $data;
    }
}