SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;


CREATE TABLE `mod_youtube` (
  `Id` int(10) UNSIGNED NOT NULL,
  `Url` varchar(256) NOT NULL,
  `Title` varchar(33) NOT NULL,
  `Body` varchar(75) NOT NULL,
  `UserId` int(10) UNSIGNED NOT NULL,
  `Approved` tinyint(1) NOT NULL,
  `ApprovedComm` varchar(256) NOT NULL DEFAULT '',
  `Active` tinyint(1) NOT NULL,
  `Pol` tinyint(1) NOT NULL DEFAULT '0',
  `Vozr_min` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `Vozr_max` tinyint(3) UNSIGNED NOT NULL DEFAULT '100',
  `B_type` enum('1','2','3') NOT NULL DEFAULT '1' COMMENT '1-безлим, 2-дневной, 3-общий',
  `B_money` float NOT NULL DEFAULT '0',
  `B_trata` float NOT NULL DEFAULT '0',
  `S_trata` float NOT NULL DEFAULT '0',
  `S_views` int(11) NOT NULL DEFAULT '0',
  `AddDate` int(11) NOT NULL,
  `Type` enum('like','subscr','dislike','view','comment') NOT NULL DEFAULT 'like',
  `ChOk` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `mod_youtube_reg` (
  `RId` int(10) UNSIGNED NOT NULL,
  `Obl` int(11) NOT NULL,
  `Country` char(2) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `mod_youtube_stat` (
  `RId` int(10) UNSIGNED NOT NULL,
  `UserId` int(10) UNSIGNED NOT NULL,
  `Ip` int(10) UNSIGNED NOT NULL,
  `AddDate` int(10) UNSIGNED NOT NULL,
  `Ok` tinyint(1) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `mod_youtube_tek` (
  `RId` int(10) UNSIGNED NOT NULL,
  `UserId` int(10) UNSIGNED NOT NULL,
  `AddDate` int(10) UNSIGNED NOT NULL,
  `Count` int(10) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


ALTER TABLE `mod_youtube`
  ADD PRIMARY KEY (`Id`),
  ADD KEY `UserId` (`UserId`),
  ADD KEY `Approved` (`Approved`),
  ADD KEY `Active` (`Active`),
  ADD KEY `B_type` (`B_type`),
  ADD KEY `B_trata` (`B_trata`);

ALTER TABLE `mod_youtube_reg`
  ADD KEY `RId` (`RId`),
  ADD KEY `Obl` (`Obl`),
  ADD KEY `Country` (`Country`);

ALTER TABLE `mod_youtube_stat`
  ADD KEY `RId` (`RId`),
  ADD KEY `UserId` (`UserId`),
  ADD KEY `Ip` (`Ip`),
  ADD KEY `AddDate` (`AddDate`);

ALTER TABLE `mod_youtube_tek`
  ADD KEY `AddDate` (`AddDate`),
  ADD KEY `UserId` (`UserId`),
  ADD KEY `Rid` (`RId`);


ALTER TABLE `mod_youtube`
  MODIFY `Id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=6835;

ALTER TABLE `mod_youtube_reg`
  ADD CONSTRAINT `mod_youtube_reg_ibfk_1` FOREIGN KEY (`Country`) REFERENCES `GeoIp_country` (`Id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `mod_youtube_reg_ibfk_3` FOREIGN KEY (`RId`) REFERENCES `mod_youtube` (`Id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `mod_youtube_stat`
  ADD CONSTRAINT `mod_youtube_stat_ibfk_2` FOREIGN KEY (`RId`) REFERENCES `mod_youtube` (`Id`) ON DELETE CASCADE ON UPDATE CASCADE;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
