<?php
namespace models;
if ( ! defined('X_F')) exit('Нет доступа!');
require_once(F."models/Base_model.php");

class Nav_model extends \models\Base_model
{
    function GetsItems($filtr, $desc = '`Sort`'){
        $ret = array();
        $conn = $this->con();
        $w = '';
        $w_ar = array();
        if(isset($filtr['ParentId']))
            array_push($w_ar, 'ParentId = '.(int)$filtr['ParentId']);

        if(isset($filtr['Active']))
            array_push($w_ar, 'Active = 1');

        if(isset($filtr['NavId']))
            array_push($w_ar, 'NavId = '.(int)$filtr['NavId']);   
        if(!empty($w_ar))
            $w = 'WHERE '.implode(' AND ', $w_ar);

        if(empty($desc))
            $desc = '`Sort`';
        else
        {
            $ar = explode(' ', trim($desc));
            $desc = $conn->real_escape_string($ar[0]).(isset($ar[1]) ? ' DESC' : '');
        }
        $query = $conn->query("SELECT * FROM Nav_item {$w} ORDER BY {$desc} LIMIT 300");
        //die("SELECT * FROM Nav_item {$w} {$desc} LIMIT 300");
        if (!empty($query) && $query->num_rows)
        {
            while($row = $query->fetch_assoc()){
                $row['child'] = array();
                $ret[$row['Id']] = $row;
            }
        }
        $conn->close();
        return $ret;
    }
    function GetsItemsSet($filtr, $desc = '`Sort`'){
        $ret = $this->GetsItems($filtr, $desc);
        foreach ($ret as $key => $val) {
            if($val['ParentId'] > 0){
                unset($ret[$key]);
                $ret[$val['ParentId']]['child'][$key] = $val;
            }
        }
        return $ret;
    }
    function Gets(){
        $ret = array();
        $conn = $this->con();
        $query = $conn->query("SELECT * FROM Nav ORDER BY Id");
        if (!empty($query) && $query->num_rows)
        {
            while($row = $query->fetch_assoc())
                $ret[$row['Id']] = $row;
        }
        $conn->close();
        return $ret;
    }
    function GetById($id){
        $id = (int)$id;
        $ret = NULL;
        $conn = $this->con();
        $query = $conn->query("SELECT * FROM Nav WHERE Id = {$id}");
        if (!empty($query) && $query->num_rows)
        {
            $row = $query->fetch_assoc();
            if(!empty($row))
                $ret = $row;
        }
        $conn->close();
        return $ret;
    }
    function GetItemById($Id){    
        $Id = (int)$Id;
        $ret = NULL;
        $conn = $this->con();
        $query = $conn->query("SELECT * FROM Nav_item WHERE Id = {$Id}");
        if (!empty($query) && $query->num_rows)
        {
            $row = $query->fetch_assoc();
            if(!empty($row))
                $ret = $row;
        }
        $conn->close();
        return $ret;
    }
    function chekChild($id){
        $conn = $this->con();
        $ret = FALSE;
        $id=(int)$id;
        $query = $conn->query("SELECT `Id` FROM Nav WHERE ParentId = {$id} LIMIT 1");
        $conn->close();            
        if(!empty($query) && $query->num_rows){
            $ret = TRUE;
            $query->close();
        }
        return $ret;
    }
    public function InsertItem($dat){
        if(empty($dat['Title']) || empty($dat['Url']))
            return FALSE;
        $data = array();
        $data['Title'] = chHtmlTag(trim($dat['Title']),0);
        $data['Url'] = mav_htmltotext(trim($dat['Url']));
        if(isset($dat['Image']))
            $data['Image'] = mav_htmltotext(trim($dat['Image']));
        if(isset($dat['Description']))
            $data['Description'] = chHtmlTag(trim($dat['Description']));
        if(isset($dat['ParentId']))
            $data['ParentId'] = (int)$dat['ParentId'];
        if(isset($dat['NavId']))
            $data['NavId'] = (int)$dat['NavId'];
        if(isset($dat['Active']))
            $data['Active'] = (int)$dat['Active'];

        $ret = $this->b_insert('Nav_item',$data,0);
        if($ret){
            $this->setnav($data['NavId']);
        }
        return $ret;
    }
    public function UpdateItem($dat){
        $data = array();
        if(empty($dat['Id']))
            return FALSE;
        if(isset($dat['Title'])){
            if(empty($dat['Title']))
                return FALSE;
            $data['Title'] = chHtmlTag(trim($dat['Title']),0);
        }
        if(isset($dat['Url'])){
            if(empty($dat['Url']))
                return FALSE;
            $data['Url'] = mav_htmltotext(trim($dat['Url']));
        }
        if(isset($dat['Image']))
            $data['Image'] = mav_htmltotext(trim($dat['Image']));
        if(isset($dat['Description']))
            $data['Description'] = chHtmlTag(trim($dat['Description']));
        if(isset($dat['ParentId']) && $dat['ParentId'] != $dat['Id'])
            $data['ParentId'] = (int)$dat['ParentId'];
        /*if(isset($dat['NavId']))
            $data['NavId'] = (int)$dat['NavId'];*/
        if(isset($dat['Sort']))
            $data['Sort'] = (int)$dat['Sort'];
        if(isset($dat['Active']))
            $data['Active'] = (int)$dat['Active'];
        if(empty($data))
            return FALSE;
        $ret = $this->b_update('Nav_item',$data,$dat['Id'],0);
        if($ret){
            if(empty($data['NavId']))
                $data['NavId'] = $this->GetItemById($dat['Id'])['NavId'];
            $this->setnav($data['NavId']);
        }
        return $ret;
    }
    public function DeleteItem($id)
    {
        $ret = FALSE;
        $conn = $this->con();
        $id=(int)$id;
        if($id){
            $ret = $conn->query("DELETE FROM `Nav_item` WHERE `Id` = {$id}");
            $conn->close();
            if($ret){
                $child = $this->GetsItems(array('ParentId' => $id));
                if($child){
                    foreach ($child as $k => $val)
                        $this->DeleteItem($k);
                }
            }
        }
        else
            $conn->close();
        return $ret;
    }
    function SortItemsAdm(&$ret, $n_ret = array(), $parent = 0, $lv = 0){
        foreach ($ret as $key => $val) {
            if($val['ParentId'] == $parent){
                $val['lv'] = $lv;
                $n_ret[$key] = $val;
                $c1 = count($n_ret);
                $n_ret = $this->SortItemsAdm($ret,$n_ret, $val['Id'], $lv + 1);
                $n_ret[$key]['ch_child'] = ($c1 < count($n_ret)) ? TRUE : FALSE;
            }
        }
        return $n_ret;
    }
    public function setnav($NavId = 1){
        $nav = $this->GetById($NavId);        
        if(!is_file(F.HTML."nav/{$nav['Template']}.php"))
            return FALSE;            
        if(($file = fopen(F."system/nav_".$nav['Name'], 'w')) !== FALSE){
            $navs = $this->GetsItemsSet(array('NavId'=>$NavId,'Active'=>TRUE));
            ob_start();
            require_once F.HTML."nav/{$nav['Template']}.php";
            $ret = ob_get_contents();
            ob_end_clean();
            fwrite($file, $ret);
            fclose($file);
            unset($file, $ret);
        }
    }
}