<?php
namespace models;
if ( ! defined('X_F')) exit('Нет доступа!');
require_once(F."models/Base_model.php");

class XUser_model extends \models\Base_model
{
    function __construct(){}
    function get()
    {
        if(empty($_SESSION['XUser']))
            return NULL;
        $ret = $this->GetBySid($_SESSION['XUser']);
        return $ret;
    }
    function Login($Login, $pass){
        $ret = array();
        $ret[0] = 0;
        $ret[1] = 'Произошла ошибка! Повторите попытку позже';
        $use = $this->GetByLogin($Login);
        if(empty($use)){
            $ret[1] = 'Нет такого пользователя';
            $this->Insert_login_error_log();
            return $ret;
        }
        $data = array();
        if(password_verify($pass, $use['Pass'])) {
            $Sid = mavrandom(30);
            $data['Sid'] =  $Sid;
            $data['Id'] =  $use['Id'];
            $data['ch'] = 0;
            if($this->Update($data)){
                $_SESSION['XUser'] = $Sid;
                $ret[0] = 1;
                $ret[1] = $use;
                $this->Insert_login_log($use['Id']);
                return $ret;
            }
            $this->Insert_login_error_log();
            return $ret;
        }
        else{
            $ret[1] = 'Неверный пароль';
            $this->Insert_login_error_log();
            return $ret;
        }
    }
    public function Gets()
    {
        $conn = $this->con();
        $ret = array();
        $query = $conn->query("SELECT * FROM `x_user` as `u`  ORDER BY `u`.`Id` LIMIT 50");
        if (!empty($query) && $query->num_rows)
            $ret = $this->convertList($query);
        $conn->close();
        return $ret;
    }
    function Logout(){
        unset($_SESSION['XUser']);
        $data = array();
        $data['Sid'] =  '';
        $data['ch'] = 0;
        $this->Update($data);
        return 1;
    }
    public  function GetByID($id,$login = 'Id',$active = FALSE)
    {
        $conn = $this->con();
        $w = NULL;
        if ($login === 'Login')
            $w = "`Login` = '".$conn->real_escape_string($id)."'";
        elseif ($login === 'Sid')
            $w = "`Sid` = '".$conn->real_escape_string($id)."'";
        else
            $w = '`Id` = '.(int)$id;
        if($active)
            $w .= ' AND `Active` = 1';
        $ret = NULL;
        $q = "SELECT * FROM `x_user`  WHERE {$w} LIMIT 1";
        //die($q);
        $query = $conn->query($q);
        if (!empty($query) && $query->num_rows)
            $ret = $this->convert($query);
        $conn->close();
        return $ret;
    }
    public function GetByLogin($Login, $ak = 1){ return $this->GetByID($Login,'Login',$ak); }
    public function GetBySid($Sid, $ak = 1){ return $this->GetByID($Sid,'Sid',$ak); }

    public  function Update($dat)
    {
        $data = array();
        $Title = '';
        $id = 0;
        if (isset($dat['Id'])) {
            $id=(int)$dat['Id'];
        }
        else
            return false;
        if(isset($dat['Login'])){
            $data['Login'] = mav_htmltotext($dat['Login']);
        }
        if(!empty($dat['Pass']))
            $data['Pass'] = password_hash($dat['Pass'], PASSWORD_DEFAULT);
        if(isset($dat['Email']))
            $data['Email'] = mav_htmltotext($dat['Email']);
        if(isset($dat['RecoveryCode']))
            $data['RecoveryCode'] = mav_htmltotext($dat['RecoveryCode']);
        if(isset($dat['RecoveryData']))
            $data['RecoveryData'] = mav_htmltotext($dat['RecoveryData']);
        if(isset($dat['RecoveryPass']))
            $data['RecoveryPass'] = mav_htmltotext($dat['RecoveryPass']);
        if(isset($dat['Fio']))
            $data['Fio'] = mav_htmltotext($dat['Fio']);
        if(isset($dat['Active']))
            $data['Active'] = (int)$dat['Active'];
        if(isset($dat['Role']))
            $data['Role'] = trim($dat['Role']);
        if(isset($dat['Sid']))
            $data['Sid'] = $dat['Sid'];
        $ret = $this->b_update('x_user',$data,$id,0);
        return $ret;
    }
    public function Insert($dat)
    {
        $data = array();
        if(empty($dat['Login']) || empty($dat['Pass']) || empty($dat['Email']))
            return false;
        $data['Login'] = mav_htmltotext($dat['Login']);
        $data['Pass'] = password_hash($dat['Pass'], PASSWORD_DEFAULT);
        $data['Email'] = mav_htmltotext($dat['Email']);
        $data['RecoveryCode'] = '';
        $data['RecoveryData'] = 0;
        $data['RecoveryPass'] = '';
        $data['Sid'] = '';
        $data['Active'] = 1;
        $data['AddDate'] = time();
        $data['Role'] = isset($dat['Role']) ? trim($dat['Role']) : '';
        $data['Fio'] = isset($dat['Fio']) ? mav_htmltotext($dat['Fio']) : '';

        $ret = $this->b_insert('x_user',$data,0);
        return $ret;
    }
    public function Delete($id)
    {
        if(!$GLOBALS['x_user_logined'] || $GLOBALS['x_user_login']['Id'] == $id)
            return false;
        $conn = $this->con();
        $id=(int)$id;
        $ret = $conn->query("DELETE FROM `x_user` WHERE `Id` = {$id}");
        $conn->close();
        return $ret;
    }
    public function passrecovery1($Email){
        $ret = "Произошла ошибка. Повторите попытку позже";
        $conn = $this->con();
        $Email = $conn->real_escape_string(trim($Email));
        $query = $conn->query("SELECT * FROM `x_user` as `u` LEFT JOIN x_user_passrecovery as r ON(r.UserId = u.Id) WHERE u.Email = '{$Email}' LIMIT 1");
        if (!empty($query) && $query->num_rows){
            $row = $query->fetch_assoc();
            if(!empty($row['RecoveryData']) && $row['RecoveryData'] > time()-60*60)
                $ret = 'Произошла ошибка! Нельзя использовать эту функцию так часто. Повторите через '.( round(((time() - $row['RecoveryData'])/60),0) ).' минут';
            else{
                if(!empty($row['RecoveryCode']))
                    $conn->query("DELETE FROM `x_user_passrecovery` WHERE `UserId` = {$row['Id']}");
                $d = array();
                $d['RecoveryCode'] = mavrandom(20);
                $d['RecoveryData'] = time();
                $d['UserId'] = $row['Id'];
                /*$d['ch'] = 0;*/
                if($this->b_insert('x_user_passrecovery',$d,0))
                {                
                    $mail_data['To'] = $row['Email'];
                    $mail_data['Tema'] = $GLOBALS['setting']['main']['org'].' - Восстановление пароля';
                    $row['d'] = $d;
                    $mail_data['Body'] = xcontent_show('mail_pass', $row, TRUE);

                    /*$ret = mav_sendmail($mail_data);*/
                    if(mav_sendmail($mail_data))
                        $ret = '';
                    else
                        $ret = 'Произошла ошибка! Не удалось отправить сообщение на Ваш E-mail';
                }
            }
        }
        else
            $ret = 'Произошла ошибка! Нет такого пользователя';
        $conn->close();            
        return $ret;
    }
    public function passrecovery2(){
        if(!isset($_GET['email'],$_GET['login'],$_GET['key']))
            return FALSE;
        $ret = FALSE;
        $conn = $this->con();
        $Login = $conn->real_escape_string(trim($_GET['login']));
        $Email = $conn->real_escape_string(trim($_GET['email']));
        $RecoveryCode = $conn->real_escape_string(trim($_GET['key']));
        $query = $conn->query("SELECT u.* FROM `x_user` as `u` INNER JOIN x_user_passrecovery as r ON(r.UserId = u.Id) WHERE u.Login = '{$Login}' AND u.Email = '{$Email}' AND r.RecoveryCode = '{$RecoveryCode}' AND r.RecoveryData > ".(time()-60*60*12)." LIMIT 1");
        //die("SELECT r.* FROM `x_user` as `u` INNER JOIN x_user_passrecovery as r ON(r.UserId = u.Id) WHERE u.Login = '{$Login}' AND u.Email = '{$Email}' AND RecoveryCode = '{$RecoveryCode}' AND RecoveryData > ".(time()-60*60*12)." LIMIT 1");
        if (!empty($query) && $query->num_rows){
            $row = $query->fetch_assoc();
            $d = array();
            $n_pass = mavrandom(8);
            $d['Pass'] = $n_pass;
            $d['Id'] = $row['Id'];
            if($this->Update($d)){
                $conn->query("DELETE FROM `x_user_passrecovery` WHERE `UserId` = {$row['Id']}");
                $mail_data['To'] = $row['Email'];
                $mail_data['Tema'] = $GLOBALS['setting']['main']['org'].' - Восстановление пароля';
                $row['d'] = $d;
                $row['n_pass'] = $n_pass;
                $mail_data['Body'] = xcontent_show('mail_pass2', $row, TRUE);
                $ret = mav_sendmail($mail_data);
            }
        }
        $conn->close();
        return $ret;
    }


    /******************************Логи****************************************/
    
    public function Insert_login_log($id){
        $data = array('UserId' => (int)$id, 'Ip' => sprintf('%u', ip2long(IP)), 'UseAgent' => $_SERVER['HTTP_USER_AGENT']);
        $this->b_insert('x_user_login_log',$data,0);
    }
    public function Gets_login_log($id,$limit = 10){
        $conn = $this->con();
        $ret = array();
        $id = (int)$id; $limit = (int)$limit;
        $query = $conn->query("SELECT `Date`,`UseAgent`, INET_NTOA(`Ip`) as `Ip` FROM `x_user_login_log` WHERE `UserId` = {$id} ORDER BY `Date` DESC LIMIT {$limit}");
        if (!empty($query))
        {
            while($row = $query->fetch_assoc())
                array_push($ret, $row);
            $query->close();
        }
        $conn->close();
        return $ret;
    }
    public function Insert_login_error_log(){
        $data = array('Date' => time(), 'Ip' => sprintf('%u', ip2long(IP)));
        $this->b_insert('x_user_login_error_log',$data,FALSE);
    }
    public function chek_login_error_log($time = 1)
    {
        $conn = $this->con();
        $ret = 0;
        $time = time() - $time*60*60;
        $ip = sprintf('%u', ip2long(IP));
        //die("SELECT COUNT(*) FROM `x_user_login_error_log` WHERE `Ip` = {$ip} AND `Date` > {$time} LIMIT 100");
        $query2 = $conn->query("SELECT COUNT(*) FROM `x_user_login_error_log` WHERE `Ip` = $ip AND `Date` > {$time} LIMIT 100");
        if(!empty($query2)){
            $ret = (int)$query2->fetch_array()[0];
            $query2->close();
        }
        $conn->close();
        return $ret;
    }
    /***************************************************/
        function convert(&$query)
        {
            $row = $query->fetch_assoc();
            if(empty($row)){
                $query->close();
                return NULL;
            }
            else
            {
                if(isset($row['Role']))
                    $row['Role'] = json_decode($row['Role'],1);
                if(isset($row['Ip']))
                    $row['Ip'] = long2ip($row['Ip']);
                if(isset($row['LastIp']))
                    $row['LastIp'] = long2ip($row['LastIp']);
                $query->close();
                return $row;
            }
        }
        function convertList(&$query)
        {
            $ret = array();
            while($row = $query->fetch_assoc())
            {
                if(isset($row['Role']))
                    $row['Role'] = json_decode($row['Role'],1);
                if(isset($row['Ip']))
                    $row['Ip'] = long2ip($row['Ip']);
                if(isset($row['LastIp']))
                    $row['LastIp'] = long2ip($row['LastIp']);
                array_push($ret, $row);
            }
            $query->close();
            return $ret;
        }

}
