<h1>Site Configuration</h1>

<?php 
	$cron = getConf('cron');
	echo (empty($cron['cronok_d'])) ? '<small>(Cron is not working)</small>' : '<small>(Last cron ran: '.date('d.m.Y H:i',$cron['cronok_d']).')</small>';
?>
<div class="feedok"><?php echo $feed; ?></div>
<form method="post">
	<div class="panel panel-primary">
		<div class="panel-heading"><strong>General Settings</strong></div>
		<div class="panel-body">
			<div class="row">
				<div class="col-sm-6">
					<div class="form-group">
						<label>Site Name:</label>
						<input type="text" name="org" value="<?php echo $set['org']; ?>" class="form-control input-sm" />
					</div>
				</div>
				<div class="col-sm-6">
					<div class="form-group">
						<label>Abbreviated Name:</label>
						<input type="text" name="short_org" value="<?php echo $set['short_org']; ?>" class="form-control input-sm" />
					</div>
				</div>
				<div class="clearfix"></div>
				<div class="col-sm-12">
					<div class="form-group">
						<label>Brief site description:</label>
						<textarea rows="2" name="desc" class="form-control input-sm"><?php echo $set['desc']; ?></textarea>
					</div>
				</div>
				<div class="col-sm-6">
					<div class="form-group">
						<label>Logo:</label>
						<input type="text" name="logo" value="<?php echo $set['logo']; ?>" class="form-control input-sm" />
					</div>
				</div>
				<div class="col-sm-6">
					<div class="form-group">
						<label>favicon:</label>
						<input type="text" name="favicon" value="<?php echo $set['favicon']; ?>" class="form-control input-sm" />
					</div>
				</div>
				<div class="clearfix"></div>
				<div class="col-sm-6">
					<div class="form-group">
						<label>E-mail:</label>
						<input type="text" name="mail" value="<?php echo $set['mail']; ?>" class="form-control input-sm" />
					</div>
				</div>
				<div class="col-sm-6">
					<div class="form-group">
						<label>Phone:</label>
						<input type="text" name="tel" value="<?php echo $set['tel']; ?>" class="form-control input-sm" />
					</div>
				</div>
				<div class="clearfix"></div>
				<div class="col-sm-6">
					<div class="form-group">
						<label>VK Group:</label>
						<input type="text" name="vk" value="<?php echo $set['vk']; ?>" class="form-control input-sm" />
					</div>
				</div>

				<div class="col-sm-6">
					<div class="form-group">
						<label>Captcha:</label>
						<select name="captcha[type]" class="form-control input-sm">
							<option <?php if($set['captcha']['type'] == 'standart') echo 'selected="selected"'; ?> value="standart">Standard</option>
							<option <?php if($set['captcha']['type'] == 'google') echo 'selected="selected"'; ?> value="google">Google Re-captcha</option>
						</select>						
					</div>
				</div>
				<div class="clearfix"></div>
				<div class="col-sm-6">
					<div class="form-group">
						<label>Control panel address:</label><br /><small>(letters only)</small>
						<div class="input-group">
							<span class="input-group-addon"><?php echo PROT."{$_SERVER['SERVER_NAME']}/" ?></span>
							<input type="text" name="x_url" value="<?php echo $set['x_url']; ?>" class="form-control input-sm" />
						</div>												
					</div>
				</div>
				<div class="col-sm-6">
					<div class="form-group">
						<label>Administrator ID:</label><br /><small>(Specify site administrator ID)</small>
						<input type="text" name="admin_id" value="<?php echo $set['admin_id']; ?>" class="form-control input-sm" />
					</div>
				</div>
				<div class="clearfix"></div>
			</div>
			<div class="clearfix"></div>
			<div class="panel panel-default">
				<div class="panel-heading">Google Re-captcha Settings<br /><small>(If used)</small></div>
				<div style="padding: 15px 0">
					<div class="col-sm-6">
						<div class="form-group">
							<label>Secret key:</label>
							<input type="text" name="captcha[google][secretkey]" value="<?php echo $set['captcha']['google']['secretkey']; ?>" class="form-control input-sm" />
						</div>
					</div>
					<div class="col-sm-6">
						<div class="form-group">
							<label>Public key:</label>
							<input type="text" name="captcha[google][publickey]" value="<?php echo $set['captcha']['google']['publickey']; ?>" class="form-control input-sm" />
						</div>
					</div>
					<div class="clearfix"></div>
				</div>
			</div>
			<div class="row">
				<div class="col-sm-12">
					<div class="form-group">
						<label>Yandex.Metrica counter number:</label>
						<br /><small>We recommend you set up <a href="https://metrika.yandex.ru" target="_blank">Yandex.Metrica</a> for visit analysis. Make the necessary settings in the service, and insert only the counter number here.</small>
						<input type="text" name="metrika" value="<?php echo $set['metrika']; ?>" class="form-control input-sm" />
					</div>
				</div>
				<div class="clearfix"></div>
				<div class="col-sm-6">
					<div class="form-group">
						<label>Moderate comments on articles:</label>
						<select name="page[com_moderat]" class="form-control input-sm">
							<option <?php if($set['page']['com_moderat'] > 0) echo 'selected="selected"'; ?> value="1">Yes</option>
							<option <?php if($set['page']['com_moderat'] < 1) echo 'selected="selected"'; ?> value="0">No</option>
						</select>
					</div>
				</div>
				<div class="clearfix"></div>
			</div>
		</div>
	</div>


	<div class="panel panel-primary">
		<div class="panel-heading"><strong>Referral System</strong></div>
		<div class="panel-body">
			<div style="margin-bottom: 15px; max-width: 300px;" class="input-group">
				<label class="input-group-addon" style="font-weight: bold;">Number of levels:</label>
				<input type="number" min="0" max="10" name="user[ref_ur]" value="<?php echo $set['user']['ref_ur']; ?>" class="form-control input-sm" />
			</div>
			<div class="panel panel-default">
				<div class="panel-heading">Percentage of deductions from earned funds:</div>
				<div style="padding: 15px 0;">
					<?php 
					$col = ($set['user']['ref_ur'] > 6) ? '3' : round(12/$set['user']['ref_ur'],0,PHP_ROUND_HALF_DOWN);
					for ($i=1; $i <= $set['user']['ref_ur']; $i++) { 
						//$col_sm = round($col/,0,PHP_ROUND_HALF_DOWN);
						$per = isset($set['user']['ref_per'][$i-1]) ? $set['user']['ref_per'][$i-1] : 0;
					?>
					<div class="col-md-<?php echo $col; ?>">
						<label>Lvl.<?php echo $i; ?> %:</label>
						<input type="number" min="0" max="100" name="user[ref_per][]" value="<?php echo $per; ?>" class="form-control input-sm" />
					</div>
					<?php } ?>
					<div class="clearfix"></div>
				</div>
			</div>
			<div class="panel panel-default">
				<div class="panel-heading">Percentage of deductions from top-ups:</div>
				<div style="padding: 15px;">					
					<div>
						<label>Level 1 (%):</label>
						<input type="number" min="0" max="100" name="user[ref_per_pay]" value="<?php echo $set['user']['ref_per_pay']; ?>" class="form-control input-sm" />
					</div>
				</div>
			</div>
		</div>
	</div>


	<p><button type="submit" class="btn btn-lg btn-danger" name="up">Save Changes</button></p>
</form>